//
//  LWWiFiViewController.m
//  APConfig
//
//  Created by wen on 2018/7/31.
//  Copyright © 2018年 wen. All rights reserved.
//

#import "LWWiFiViewController.h"
#import <SystemConfiguration/CaptiveNetwork.h>
#import "HttpRequest.h"
#import "MBProgressHUD+MJ.h"
#import "LWConfigViewController.h"
#import <NetworkExtension/NEHotspotConfigurationManager.h>
#import "LWControlHeader.h"
#import "LWBasicNetWorkTools.h"
#import "LoadingView.h"
#import "HttpRequest.h"
#import <CoreLocation/CoreLocation.h>

@interface LWWiFiViewController ()

@property (weak, nonatomic) IBOutlet UILabel *versionLabel;
@property (weak, nonatomic) IBOutlet UILabel *ssidLabel;
@property (weak, nonatomic) IBOutlet UITextField *wifiPwdTextField;
@property (weak, nonatomic) IBOutlet UITextField *ssidPrefixTextField;
@property (weak, nonatomic) IBOutlet UITextField *apPwdTextField;
@property (weak, nonatomic) IBOutlet UIButton *nextBtn;
@property (weak, nonatomic) IBOutlet UILabel *errorLabel;
@property (nonatomic, strong) CLLocationManager *locationManager;

/**模块热点前缀*/
@property (nonatomic, strong) NSString *ssidPrefix;
/**模块要连的wifi*/
@property (nonatomic, strong) NSString *netSSID;
/**手机当前连接的wifi*/
@property (nonatomic, strong) NSString *currentSSID;
/**模块要连的wifi密码*/
@property (nonatomic, strong) NSString *wifiPwd;
/**模块热点密码*/
@property (nonatomic, strong) NSString *deviceWiFiPwd;

@property (nonatomic, assign) BOOL isOpen;

@property (nonatomic, strong) NSTimer *timer;

@end

@implementation LWWiFiViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    [self.wifiPwdTextField becomeFirstResponder];
//    self.ssidPrefix = @"hiflying_softap";
    self.ssidPrefix = @"Kolin_KCO_A12S";
    self.apPwdTextField.text = @"Kolin@0771";
    self.ssidPrefixTextField.text = self.ssidPrefix;
//    [self configContentView];
    
    
    
    self.versionLabel.text = [NSString stringWithFormat:@"version:%@.%@",[[[NSBundle mainBundle]infoDictionary] objectForKey:@"CFBundleShortVersionString"],[[[NSBundle mainBundle]infoDictionary] objectForKey:@"CFBundleVersion"]];


    
}

-(void)viewWillAppear:(BOOL)animated{
    [super viewWillAppear:animated];
    [[NSNotificationCenter defaultCenter ] addObserver:self selector:@selector(updateUI) name:@"KOnWillEnterForeground" object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(networkChange:) name:@"kOnNetworkReachabilityStatusChange" object:nil];


//    NSString* phoneVersion = [[UIDevice currentDevice] systemVersion];
//    CGFloat version = [phoneVersion floatValue];
//    // 如果是iOS13 未开启地理位置权限 需要提示一下
//    if ([CLLocationManager authorizationStatus] == kCLAuthorizationStatusNotDetermined && version >= 13) {
//        self.locationManager = [[CLLocationManager alloc] init];
//        [self.locationManager requestWhenInUseAuthorization];
//    }else{
//        [self configContentView];
//    }
    
    [self configContentView];

}

-(void)viewDidDisappear:(BOOL)animated{
    [super viewDidDisappear:animated];
//    [[NSNotificationCenter defaultCenter] removeObserver:self];
}

- (void)dealloc {
    [[NSNotificationCenter defaultCenter] removeObserver:self];
}

- (void)networkChange:(NSNotification *)noti {
    [self configContentView];
}

-(void)configContentView{
    
    NSString* phoneVersion = [[UIDevice currentDevice] systemVersion];
      CGFloat version = [phoneVersion floatValue];
    _isOpen = NO;
    if ([CLLocationManager authorizationStatus] == kCLAuthorizationStatusNotDetermined && version >= 13) {
          
        _isOpen = YES;
        self.locationManager = [[CLLocationManager alloc] init];
        [self.locationManager requestWhenInUseAuthorization];
        [self  performSelector:@selector(configContentView) withObject:nil afterDelay:5];
        
        return;
    }else if ([CLLocationManager authorizationStatus] == kCLAuthorizationStatusDenied && version >= 13){
         UIAlertController* alert = [UIAlertController alertControllerWithTitle:@"Title"
                                                            message:@"To get the router name, go to the Settings page to open application location permissions."
                                                                preferredStyle:UIAlertControllerStyleAlert];
        UIAlertAction* defaultAction = [UIAlertAction actionWithTitle:@"OK" style:UIAlertActionStyleDefault
                                                                 handler:^(UIAlertAction * action) {
                                                                     //响应事件
                                                                     NSLog(@"action = %@", action);
            [self skipSettingVC];
                                                                 }];
        [alert addAction:defaultAction];
        [self presentViewController:alert animated:YES completion:nil];
    
        return;
    }
    
    id info = [self fetchSSIDInfo];
    self.ssidLabel.text = [info objectForKey:@"SSID"];
    if ([self.ssidLabel.text containsString:@"hiflying_softap"]) {
          [self.nextBtn setTitle:@"To set up" forState:UIControlStateNormal];
          self.errorLabel.text = @"Select the WIFi the device will connect to";
      }else{
          [self.nextBtn setTitle:@"Next" forState:UIControlStateNormal];
          self.errorLabel.text = @"";
      }
      
      if (self.ssidLabel.text) {
          if (self.timer) {
              [self.timer invalidate];
              self.timer = nil;
          }

          NSString *pwd = [[NSUserDefaults standardUserDefaults] objectForKey:self.ssidLabel.text];
          if (pwd) {
              self.wifiPwdTextField.text = pwd;
          }
      } else {
          [self.timer invalidate];
          self.timer = nil;
          __weak typeof(self) weakSelf = self;
          self.timer = [NSTimer scheduledTimerWithTimeInterval:2.0 repeats:YES block:^(NSTimer * _Nonnull timer) {
              [weakSelf checkWifi];
          }];
          [self.timer fire];
      }
    
}

- (void)checkWifi {
    id info = [self fetchSSIDInfo];
    if ([info objectForKey:@"SSID"]) {
        [self.timer invalidate];
        self.timer = nil;
        [self configContentView];
    }
}

#pragma mark - UI事件
- (IBAction)startBtnDidClicked:(id)sender {
#pragma mark - 验证加密
//    [HttpRequest connectModuleWithWiFiPwd:@"12345678" withNetSSID:@"HF-TEST" withSSID:@"hfsoftap_A6F6"];
//    [HttpRequest connectModuleWithWiFiPwd:@"12345678" withNetSSID:@"hfsoftap_A6F6" withSSID:@"hfsoftap_A6F6"];
   // kCLAuthorizationStatusDenied
   // kCLAuthorizationStatusNotDetermined
    
//
    NSString* phoneVersion = [[UIDevice currentDevice] systemVersion];
        CGFloat version = [phoneVersion floatValue];
      if (([CLLocationManager authorizationStatus] == kCLAuthorizationStatusNotDetermined && version >= 13)||([CLLocationManager authorizationStatus] == kCLAuthorizationStatusDenied && version >= 13)) {
            
          self.locationManager = [[CLLocationManager alloc] init];
          [self.locationManager requestWhenInUseAuthorization];
          [self  performSelector:@selector(configContentView) withObject:nil afterDelay:5];
          return;

      }
 

    self.netSSID = self.ssidLabel.text ;
    self.wifiPwd = self.wifiPwdTextField.text;
    self.deviceWiFiPwd = self.apPwdTextField.text;
    if ([self.netSSID containsString:@"hiflying_softap"]) {

        self.errorLabel.text = @"Please select the wifi hotspot that the hardware needs to connect to first";
        [self performSelector:@selector(skipSettingVC) withObject:nil afterDelay:0.35];

    }else{

        if (self.netSSID.length == 0) {

            self.errorLabel.text = @"Connect your phone to wifi";
            [self performSelector:@selector(skipSettingVC) withObject:nil afterDelay:0.35];
            return;
        }else{
            if (self.deviceWiFiPwd.length >0 ) {

                if (self.deviceWiFiPwd.length >= 8) {
                    [self pushConfigVC];
                }else{
                    self.errorLabel.text = @"Please enter a device hotspot password greater than 8 bits";
                }

            }else{

                [self pushConfigVC];

            }

        }
    }
}

-(void)skipSettingVC{
    [[UIApplication sharedApplication]openURL:[NSURL URLWithString:UIApplicationOpenSettingsURLString]];
}


-(void)pushConfigVC{
    UIStoryboard *wifiStoryboard = [UIStoryboard storyboardWithName:@"LWWiFiStoryboard" bundle:nil];
    LWConfigViewController *configVC = [wifiStoryboard instantiateViewControllerWithIdentifier:@"LWConfigViewController"];
    configVC.netSSID = self.netSSID;
    configVC.netPwd  = self.wifiPwd;
    [self.navigationController pushViewController:configVC animated:YES];
}




-(void)updateUI{
    [self configContentView];
}


#pragma mark- GetSSID
- (id)fetchSSIDInfo {
    NSArray *ifs = (__bridge_transfer id)CNCopySupportedInterfaces();
    id info = nil;
    for (NSString *ifnam in ifs) {
        info = (__bridge_transfer id)CNCopyCurrentNetworkInfo((__bridge CFStringRef)ifnam);
        if (info && [info count]) { break; }
    }
    return info;
}



- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}


-(void)touchesBegan:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event{
    [self.wifiPwdTextField resignFirstResponder];
    [self.ssidPrefixTextField resignFirstResponder];
    [self.apPwdTextField resignFirstResponder];
}




/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
